 #include <stdio.h>
#include <sys/times.h>
#include <linux/fs.h>
#include <linux/timer.h>
#include <linux/genhd.h>
#include <linux/errno.h>
#include <linux/major.h>
#include <linux/mman.h>
#include  <linux/hdreg.h>

#define GFP_KERNEL 0x03

#include "config.h"

#ifdef USE_VARARGS
#include <varargs.h>
#else
#include <stdarg.h>
#endif

#define NGROUPS 32
#define RLIM_NLIMITS 6

int intr_count = 0;
int disable_irq(int number)
{
  return 0;
}

int enable_irq(int number)
{
  return 0;
}


#ifndef FAKE_BUFFERS
void * pages[NR_PAGES];
void * shpage[NR_PAGES];
char pageavl[NR_PAGES];
#endif

struct task_struct {
/* these are hardcoded - don't touch */
	long state;		/* -1 unrunnable, 0 runnable, >0 stopped */
	long counter;
	long priority;
	unsigned long signal;
	unsigned long blocked;	/* bitmap of masked signals */
	unsigned long flags;	/* per process flags, defined below */
	int errno;
	int debugreg[8];  /* Hardware debugging registers */
/* various fields */
};

static double
  time_so_far()
{
  clock_t        val;
  struct tms tms;


  if ((val = times(&tms)) == -1)
    perror("times");

  return ((double) val) / ((double) CLK_TCK);
}

#ifdef USE_VARARGS
void panic(va_alist)
  va_dcl
#else
void panic(char *format, ...)
#endif
{
  va_list vp;
#ifdef USE_VARARGS
  char *format;
#endif

  fprintf(stderr, "kbench: ");

#ifdef USE_VARARGS
  va_start(vp);
  format = va_arg (vp, char *);
#else
  va_start(vp, format);
#endif
  vfprintf(stderr, format, vp);
  va_end(va);

  fputc('\n', stderr);

  exit(1);
}

int check_cdrom_media_change(){ return 0; }
int floppy_change(struct buffer_head * bh){ return; }
void invalidate_inodes(dev_t dev){ return; }
void put_super(dev_t dev){ return; }
void sync_supers(dev_t dev){ return; }
void sync_inodes(dev_t dev){ return; }
int hd_init(int a, int b){ return a; }
int rd_init(int a, int b){ return a; }
int verify_area(int type, void * arg, int size) { return 0;}
int wp_works_ok = 1;

int __verify_write(int i, int j)
{
  return 0;
}


unsigned long timer_active;
struct timer_struct timer_table[32];

volatile int jiffies = 10000;
extern int nr_hash;
extern struct buffer_head ** hash_table;

int need_resched = 0;
int ramdisk_size = 0;
int nr_free_pages = 0;
int high_memory = NR_PAGES * 4096;
unsigned short int int_mem_map[NR_PAGES + 1024];
unsigned short int * mem_map = &int_mem_map[0];
static int current_minor = 0;
struct gendisk *gendisk_head = NULL;


struct task_struct task[2];
struct task_struct * current = &task[1];

struct super_block super_blocks[NR_SUPER];

int schedule(){
  fprintf(stderr,"Schedule");
  exit(1);
}

#ifdef FAKE_BUFFERS
int free_page(void * page){
  fprintf(stderr,"Free page %x\n", page);
  exit(1);
}

void * __get_free_page(int prior){
  fprintf(stderr,"Get free page %x\n", prior);
  exit(1);
}
#else
int free_page(void * page){
  int i, map_nr;
  struct buffer_head * bh, *tmp;
  
  for(i=0; i<NR_PAGES; i++)
    if(page == pages[i]) break;

  if(i == NR_PAGES) {
    fprintf(stderr,"Attempt to free unknown page %x\n", page);
    exit(1);
  }

  if(pageavl[i]) fprintf(stderr,"Attempt to free free page %x\n", page);
  map_nr = --mem_map[(((unsigned int)pages[i]) >> 12)];
  if(map_nr == 0){
    pageavl[i] = 1;
    nr_free_pages++;
  };
  if(map_nr == 1) {
    int j;
    bh = buffer_pages[(((unsigned int)pages[i]) >> 12)];
    if(bh)
      for(j = 0, tmp = bh; tmp && (!j || tmp != bh); tmp = tmp->b_this_page, j++)
	refile_buffer(tmp);
  }
  return;
}

void * __get_free_page(int prior){
  int i;
  while(1==1){
    for(i=0; i<NR_PAGES; i++){
      if(pageavl[i]){
	pageavl[i] = 0;
	mem_map[(((unsigned int)pages[i]) >> 12)]++;
	nr_free_pages--;
	return pages[i];
      };
    };
    shrink_buffers(prior);
  };
}

#endif

int sleep_on(struct wait_queue ** foo){
  fprintf(stderr,"Sleeping...\n");
  sleep(1);
}

int interruptible_sleep_on(struct wait_queue ** foo){
  fprintf(stderr,"Sleeping...\n");
  sleep(1);
}

void * vmalloc(int size){
  return malloc(size);
}

void resetup_one_dev(struct gendisk *dev, int drive)
{
}

struct file_operations * blkdev_fops[MAX_BLKDEV] = {
	NULL,
};

int register_blkdev(unsigned int major, const char * name, struct file_operations *fops)
{
	if (major >= MAX_BLKDEV)
		return -EINVAL;
	if (blkdev_fops[major])
		return -EBUSY;
	blkdev_fops[major] = fops;
	return 0;
}

int wake_up(struct wait_queue ** foo){
  if((*foo) == NULL) return;
  fprintf(stderr,"Wake up!\n");
}

#ifdef FAKE_BUFFERS
char test_buffer[8192];
#endif

char test_buffer2[IO_BLOCKSIZE];
extern struct buffer_head * free_list;

struct blk_dev_struct {
	void (*request_fn)(void);
	struct request * current_request;
};


extern struct blk_dev_struct blk_dev[10];
#define HD_CURRENT (blk_dev[HD_MAJOR].current_request)

struct request {
	int dev;		/* -1 if no request */
	int cmd;		/* READ or WRITE */
	int errors;
	unsigned long sector;
	unsigned long nr_sectors;
	unsigned long current_nr_sectors;
	char * buffer;
	struct task_struct * waiting;
	struct buffer_head * bh;
	struct buffer_head * bhtail;
	struct request * next;
};


#if 1
void fake_disk_fn(void){
	struct request * req;
	struct buffer_head * bh;

	if(!HD_CURRENT) return;
	req = HD_CURRENT;
	if(req->dev == -1) return;  /* This must be a plug */
      repeat:
	if ((bh = req->bh) != NULL) {
		req->bh = bh->b_reqnext;
		bh->b_reqnext = NULL;
		bh->b_uptodate = 1;
		bh->b_lock = 0;
		if ((bh = req->bh) != NULL) {
			req->current_nr_sectors = bh->b_size >> 9;
			if (req->nr_sectors < req->current_nr_sectors) {
				req->nr_sectors = req->current_nr_sectors;
				printk("end_request: buffer-list destroyed\n");
			}
			req->buffer = bh->b_data;
			goto repeat;
		}
	}
	HD_CURRENT = req->next;
	req->dev = -1;
}
#endif


/* We keep this separate so that we know how much time we spend here */

int setup(){
  struct buffer_head * bh, *bhprev, *bhpage;
  char * start, *end;
  int i;
  int j;
  char * start_buffer;

  nr_buffers = 0;
  for(i=0; i<NR_PAGES + 1024; i++) mem_map[i] = 0;


#ifdef FAKE_BUFFERS
  free_list = (struct buffer_head *) malloc(sizeof(struct buffer_head));
  free_list->b_prev_free = free_list;
  free_list->b_next_free = free_list;

  if (high_memory >= 4*1024*1024) {
    nr_hash = 4093;
  } else {
    nr_hash = 997;
  };

  hash_table = (struct buffer_head **) malloc(nr_hash * 
						     sizeof(struct buffer_head *));
  for (i = 0 ; i < nr_hash ; i++)
    hash_table[i] = NULL;

  bhprev = NULL;

  start_buffer = (char *) ((((unsigned int) test_buffer) + 4095) & 0xfffff000);
  for(i=0; i<15000; i++){
    bh = (struct buffer_head *) malloc(sizeof(struct buffer_head));
    bh->b_size = 1024;
    bh->b_dev = 0x301;
    bh->b_data = start_buffer + ((i % 4) * 1024);
    bh->b_blocknr = i;
    bh->b_lock = 0;
    if(i < NR_SHARED * 4) bh->b_lock = 1;
    if((i % 4) == 0) {
      if (bhprev) bhprev->b_this_page = bhpage;
      bhpage = bh;
    } else {
      bhprev->b_this_page = bh;
    };
    bhprev = bh;
    nr_buffers++;
    insert_into_queues(bh);
    buffermem++;
  };
#else
  j = 0;
  for(i=0; i<NR_PAGES; i++){
    if (j >= NR_PAGES) j = 1;
    pages[j] = (void *) malloc(4096);
    *((char*)(pages[j])) = 1; /* Force a page fault */
    *((char*)(pages[j])) = 0; /* Force a page fault */
    nr_free_pages++;
    pageavl[j] = 1;
    j += 2;
  };

  /* We need to overallocate buffer_pages */
  high_memory += 1024;
  buffer_init();
  high_memory -= 1024;

  blk_dev_init(0, 0);

#if MAJOR_NR == SCSI_DISK_MAJOR
  start = (char *) malloc(50000);
  end = start + 50000;
  start = scsi_dev_init(start, end);
  sd_geninit();
#endif

  blk_dev[HD_MAJOR].request_fn = fake_disk_fn;

#ifdef NR_SHARED
  {
    char * page;
    int j;
    int nr[4];

    for(i=0; i<NR_SHARED; i++) {
      page = __get_free_page(GFP_KERNEL);
      for(j=0; j<4; j++) nr[j] = i*4+j+0x100000;
      page = bread_page(page, 0x300, nr, 1024, PROT_READ);
      shpage[i] = page;
    }
  }
#endif

#ifdef GROW_BUFFERS
  while(nr_free_pages > 20) grow_buffers(GFP_KERNEL, BLOCK_SIZE);
#endif
#endif
}

extern int memcpy_called, memcpy_bytes;

main(int argc, char * argv[]){
  double starttime, endtime, datarate;
  struct file filep;
  struct inode ind;
  int param;
  int values[3];
  int i, j;
  int mb;

  if(argc < 2) exit(0);
  sscanf(argv[1], "%d", &mb);

  setup();

  filep.f_pos = 0;
  filep.f_reada = 0;
  ind.i_rdev = (MAJOR_NR << 8);  /* Simulate an IDE disk */

/*  sd_ioctl(&ind, &filep, HDIO_REQ, &values); */

#if 0
  for(i=0; i<10; i++)
    grow_buffers(0, 1024);
  for(i=0; i<10; i++)
    grow_buffers(0, 2048);
  for(i=0; i<10; i++)
    shrink_specific_buffers(6, 1024);
  for(i=0; i<10; i++)
    shrink_specific_buffers(6, 2048);
#endif

  report();

  if(argc > 2) {
    sys_bdflush(6,(int) &param);
    printf("Old value = %d\n", param);
    sscanf(argv[2],"%d", &param);
    sys_bdflush(7, param);
  }

#ifdef DO_WRITE
  i = 0;
  starttime = time_so_far();
  do{
    block_write(&ind, &filep, test_buffer2, sizeof(test_buffer2));
    jiffies++;
  } while(filep.f_pos < mb*1000*1024);

  endtime = time_so_far() - starttime;
  datarate = filep.f_pos / endtime;
  fprintf(stderr,"Finished writing, %g seconds, datarate=%g\n", endtime, datarate);
  report();
  sys_sync();
#endif
  report();

  for(i=0; i<1; i++){
    starttime = time_so_far();
    filep.f_pos = 0;
    filep.f_reada = 0;
    
    do{
      block_read(&ind, &filep, test_buffer2, sizeof(test_buffer2));
      jiffies++;
      if((filep.f_pos % 10000) == 0) fprintf(stderr,"%d ", filep.f_pos);
    } while(filep.f_pos < mb*1000*1024);
    
    report();
    
    endtime = time_so_far() - starttime;
    datarate = filep.f_pos / endtime;
    fprintf(stderr,"Finished reading, %g seconds, datarate = %g\n", endtime, datarate);
  };

#ifndef FAKE_BUFFERS
  for(i=0; i<NR_SHARED; i++)
    free_page(shpage[i]);
#endif

  report();
  printf("memcpy was called %d times, %d bytes\n", memcpy_called, memcpy_bytes);
/*  show_stats(); */
  return 0;
}


extern int nr_buffers_type[];

report(){
  int i;
  show_buffers();
#if 0
  for(i=0; i<6; i++) printf("%d ", nr_buffers_type[i]);
  printf("\n");
#endif

}


#ifndef __OPTIMIZE__
void wait_on_buffer(struct buffer_head * bh)
{
	if (bh->b_lock)
		__wait_on_buffer(bh);
}


void lock_buffer(struct buffer_head * bh)
{
	if (bh->b_lock)
		__wait_on_buffer(bh);
	bh->b_lock = 1;
}

void unlock_buffer(struct buffer_head * bh)
{
	bh->b_lock = 0;
	wake_up(&bh->b_wait);
}

#define cli()
#define sti()
#define save_flags(X) 1
#define restore_flags(X) 1

void add_wait_queue(struct wait_queue ** p, struct wait_queue * wait)
{
	unsigned long flags;

#ifdef DEBUG
	if (wait->next) {
		unsigned long pc;
		__asm__ __volatile__("call 1f\n"
			"1:\tpopl %0":"=r" (pc));
		printk("add_wait_queue (%08x): wait->next = %08x\n",pc,(unsigned long) wait->next);
	}
#endif
	save_flags(flags);
	cli();
	if (!*p) {
		wait->next = wait;
		*p = wait;
	} else {
		wait->next = (*p)->next;
		(*p)->next = wait;
	}
	restore_flags(flags);
}

void remove_wait_queue(struct wait_queue ** p, struct wait_queue * wait)
{
	unsigned long flags;
	struct wait_queue * tmp;
#ifdef DEBUG
	unsigned long ok = 0;
#endif

	save_flags(flags);
	cli();
	if ((*p == wait) &&
#ifdef DEBUG
	    (ok = 1) &&
#endif
	    ((*p = wait->next) == wait)) {
		*p = NULL;
	} else {
		tmp = wait;
		while (tmp->next != wait) {
			tmp = tmp->next;
#ifdef DEBUG
			if (tmp == *p)
				ok = 1;
#endif
		}
		tmp->next = wait->next;
	}
	wait->next = NULL;
	restore_flags(flags);
#ifdef DEBUG
	if (!ok) {
		printk("removed wait_queue not on list.\n");
		printk("list = %08x, queue = %08x\n",(unsigned long) p, (unsigned long) wait);
		__asm__("call 1f\n1:\tpopl %0":"=r" (ok));
		printk("eip = %08x\n",ok);
	}
#endif
}

unsigned long get_free_page(int priority)
{
	unsigned long page;

	page = __get_free_page(priority);
	if (page)
		__asm__ __volatile__("rep ; stosl"
			: /* no outputs */ \
			:"a" (0),"c" (1024),"D" (page)
			:"di","cx");
	return page;
}

#endif



#if MAJOR_NR == HD_MAJOR
void revalidate_scsidisk(dev_t dev, int i){
  return;
}

int check_scsidisk_media_change(dev_t dev, int i){
  return;
}


#endif

#undef MAJOR_NR
#include "scsi.h"

int scsi_wait_for_timeout(Scsi_Cmnd * SCpnt)
{
  printf("waiting for timeout\n");
  jiffies += SCpnt->timeout + 10;
  scsi_main_timeout();
  jiffies += SCpnt->timeout;
  scsi_main_timeout();
  jiffies += SCpnt->timeout;
  scsi_main_timeout();
  jiffies += SCpnt->timeout;
  scsi_main_timeout();
  jiffies += SCpnt->timeout;
  scsi_main_timeout();
  exit(0);
}
